<?php

// Id used to identify this page within functions.
$PageID = "COMMUNICATION";

require_once "common.inc";

require_once "config.inc";
require_once "constants.inc";
require_once "db.inc";
require_once "error.inc";
require_once "layout.inc";
require_once "mgmnt.inc";
require_once "language.inc";

layout_header();

if(isset($_REQUEST['recepient']) && is_numeric($_REQUEST['recepient']) && isset($_REQUEST['send']))
{
	if(!check_priv("ADMIN"))
	{
        $superiors = superiors_list();
		$sysadmins = system_admins_list();

		if(!array_key_exists($_REQUEST['recepient'], $superiors) && !array_key_exists($_REQUEST['recepient'], $sysadmins))
		{
			error("session violation");
		}
	}

	if(isset($_REQUEST['hidden']) && $_REQUEST['hidden'] != "")
		$hidden = "\n\n".$_REQUEST['hidden'];
	else
		$hidden = $_REQUEST['hidden'];

	$res = mysql_query(	"INSERT INTO messages
						SET message_to_id=".$_REQUEST['recepient'].",
						message_from_id=".USER_ID.",
						message_sent=NOW(),
						message_nature='".$_REQUEST['nature']."',
						message_subject='".$_REQUEST['subject']."',
						message_text='".$_REQUEST['message'].$hidden."',
						message_read=0");

	if(mysql_affected_rows())
		layout_page_title($langText['MESSAGE_SEND_SUCCESS'], 'ok');
}

elseif(isset($_REQUEST['message_id']) && is_numeric($_REQUEST['message_id']) && isset($_REQUEST['delete']))
{
    $res = mysql_query("SELECT * FROM messages WHERE message_id=".$_REQUEST['message_id']);
	$row = mysql_fetch_array($res);

	if($row['message_to_id'] != USER_ID) {
		error("session violation2");
	}

	$res = mysql_query("DELETE FROM messages WHERE message_id=".$_REQUEST['message_id']);

	if(mysql_affected_rows())
		layout_page_title($langText['MESSAGE_DELETE_SUCCESS'], 'ok');
}

elseif(isset($_REQUEST['recepient']) && $_REQUEST['recepient'] == 'dev')
{
	$message = "From: ".USER_GIVEN_NAMES." ".USER_SURNAME." (User: ".USER_NAME."/".USER_ID.")\n";
	$message .= "User-Agent: " . getenv("HTTP_USER_AGENT") . "\n";
	$message .= "Host: " . getenv("REMOTE_ADDR") . "\n";
	$message .= "Nature: " . $langText['NATURE_'.$_REQUEST['nature']] . "\n";
	$message .= "Subject: " . $_REQUEST['subject'] . "\n";
	$message .= "Message:\n\n" . $_REQUEST['message'];
	$headers = "From: Emilda <Emilda@" . getenv("SERVER_NAME") . ">\r\n";
	$result = mail($config['developers_email'], "Emilda - " . $langText['NATURE_'.$_REQUEST['nature']] . ": " . $_REQUEST['subject'], $message, $headers);

	if($result)
		layout_page_title($langText['MESSAGE_SEND_SUCCESS'], 'ok');
}

elseif (isset($_REQUEST['recepient']) && $_REQUEST['recepient'] == '') {
	layout_page_title($langText['MESSAGE_SEND_ERROR'], 'error');
}
	

layout_page_title();

?>

<table border="0" cellspacing="0" cellpadding="0">
	<tr>
		<td align="left" valign="top" rowspan="2">

		<form name='im' action='<?php echo getenv('REQUEST_URI')?>' method='post'>
			<table cellpadding=0 cellspacing=0 border=0>
				<tr>
					<td colspan=2><b><?php echo $langText['TO']?></b></td>
				</tr>
				<tr>
					<td colspan=2>&nbsp;</td>
				</tr>
				<tr>
					<td>&nbsp;&nbsp;&nbsp;&nbsp;</td>
					<td>
						<select name='recepient'>
							<option value=''><?php echo $langText['CHOOSE']?></option>

							<?php

							if(check_priv("ADMIN"))
							{
								$selected = "";
								print "<option value=''>[".$langText['ALL_USERS']."]</option>";

								$res = mysql_query("SELECT user_given_names, user_surname, user_id FROM users ORDER BY user_surname");

								while($row = mysql_fetch_array($res))
								{
									$selected = "";

									if(isset($_REQUEST['recepient']) && $_REQUEST['recepient'] == $row['user_id'] && !isset($_REQUEST['send']) && !isset($_REQUEST['delete']))
										$selected = " selected";

									if($row['user_id'] != USER_ID)
										print "<option value=".$row['user_id'].$selected.">&nbsp;&nbsp;&nbsp;".$row['user_surname'].", ".$row['user_given_names']."</option>";
								}
							}

							?>


							<?php

							if(!check_priv("ADMIN"))
							{
								print "<option value=''>[".$langText['GROUP_ADMIN']."]</option>";

								foreach(superiors_list() as $id => $name)
								{
									$selected = "";

									if(isset($_REQUEST['recepient']) && $_REQUEST['recepient'] == $id && !isset($_REQUEST['send']) && !isset($_REQUEST['delete']))
										$selected = " selected";

									print "<option value='" . $id . "'" . $selected . ">&nbsp;&nbsp;&nbsp;" . $name . "</option>";
								}


								print "<option value=''>[".$langText['SYSTEM_ADMIN']."]</option>";

								foreach(system_admins_list() as $id => $name)
								{
									$selected = "";

									//print "REC: ".$_REQUEST['recepient'];
									if(isset($_REQUEST['recepient']) && $_REQUEST['recepient'] == $id && !isset($_REQUEST['send']) && !isset($_REQUEST['delete']))
										$selected = " selected";

									print "<option value='" . $id . "'" . $selected . ">&nbsp;&nbsp;&nbsp;" . $name . "</option>";
								}
							}

							?>

							<option value='dev'><?php echo $langText['DEVELOPERS']?></option>
						</select>
					</td>
				</tr>
				<tr>
					<td colspan=2>&nbsp;</td>
				</tr>
				<tr>
					<td colspan=2><b><?php echo $langText['MESSAGE_NATURE']?></b></td>
				</tr>
				<tr>
					<td colspan=2>&nbsp;</td>
				</tr>
				<tr>
					<td>&nbsp;</td>
					<td>
						<select name='nature'>
							<option value=0><?php echo $langText['CHOOSE']?></option>
							<option value=1 <?php if(isset($_REQUEST['nature']) && $_REQUEST['nature'] == 1 && !isset($_REQUEST['send']) && !isset($_REQUEST['delete'])) print " selected"?>><?php echo $langText['NATURE_1']?></option>
							<option value=2 <?php if(isset($_REQUEST['nature']) && $_REQUEST['nature'] == 2 && !isset($_REQUEST['send']) && !isset($_REQUEST['delete'])) print " selected"?>><?php echo $langText['NATURE_2']?></option>
							<option value=3 <?php if(isset($_REQUEST['nature']) && $_REQUEST['nature'] == 3 && !isset($_REQUEST['send']) && !isset($_REQUEST['delete'])) print " selected"?>><?php echo $langText['NATURE_3']?></option>
							<option value=4 <?php if(isset($_REQUEST['nature']) && $_REQUEST['nature'] == 4 && !isset($_REQUEST['send']) && !isset($_REQUEST['delete'])) print " selected"?>><?php echo $langText['NATURE_4']?></option>
						</select>
					</td>
				</tr>
				<tr>
					<td colspan=2>&nbsp;</td>
				</tr>
				<tr>
					<td colspan=2><b><?php echo $langText['SUBJECT']?></b></td>
				</tr>
				<tr>
					<td colspan=2>&nbsp;</td>
				</tr>
				<tr>
					<td>&nbsp;</td>
					<td><input type='text' name='subject' size=32 value='<?php if(isset($_REQUEST['subject']) && !isset($_REQUEST['send']) && !isset($_REQUEST['delete'])) print $_REQUEST['subject'];?>'></td>
				</tr>
				<tr>
					<td colspan=2>&nbsp;</td>
				</tr>
				<tr>
					<td colspan=2><b><?php echo $langText['MESSAGE']?></b></td>
				</tr>
				<tr>
					<td colspan=2>&nbsp;</td>
				</tr>
				<tr>
					<td>&nbsp;</td>
					<td><textarea name='message' cols="40" rows="10" class='textarea'><?php if(isset($_REQUEST['message']) && !isset($_REQUEST['send']) && !isset($_REQUEST['delete'])) print $_REQUEST['message'];?></textarea></td>
					<input type='hidden' name='hidden' value='<?php if(isset($_REQUEST['hidden']) && !isset($_REQUEST['send']) && !isset($_REQUEST['delete'])) print $_REQUEST['hidden'];?>'>
				</tr>
				<tr>
					<td colspan=2>&nbsp;</td>
				</tr>
				<tr>
					<td colspan=2 align='right'><input type='submit' name='send' value='<?php echo $langText['BUTTON_SEND']?>&nbsp;&gt;&gt;' class='button'></td>
				</tr>
			</table>
		</form>

		</td>
		<td rowspan="2" width="40">
		<td align="left" valign="top" height="1">

        <?php

		$res = mysql_query(	"SELECT *, UNIX_TIMESTAMP(messages.message_sent) AS sent_epoch
							FROM messages
							WHERE messages.message_to_id=".USER_ID."
							ORDER BY message_sent DESC");

		if(mysql_num_rows($res))
		{
        	layout_page_info($langText['MESSAGE_LISTING']);

			$headers = array("&nbsp;", $langText['FROM'], $langText['NATURE'], $langText['SUBJECT'], $langText['SENT']);
			layout_table_header($headers);

			while($row = mysql_fetch_array($res))
			{
				if($row['message_from_id'] == 0) {
					$loc = mysql_fetch_array(mysql_query("SELECT location_name FROM locations WHERE location_id=".USER_LOCATION));
					$user_row['user_given_names'] = $loc['location_name'];
					$user_row['user_surname'] = "";
				} else {
					$res_ = mysql_query("SELECT user_given_names, user_surname FROM users WHERE user_id=".$row['message_from_id']);
					if(mysql_num_rows($res_)) {
						$temp_row = mysql_fetch_array($res_);
						$user_row = $temp_row;
					} else {
						$user_row['user_given_names'] = "-";
						$user_row['user_surname'] = "";
					}
				}
				
				$row['message_subject'] = ($row['message_subject'] == "") ? "[".$langText['NO_SUBJECT']."]" : $row['message_subject'];
				
				if($row['message_read'] == 0)
				{
					$content = array(	"<a href='communication.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&action=show&message_id=".$row['message_id']."'>".layout_insertImg("icon_new_mail.png")."</a>",
										"<b>".format_user_real_name($user_row)."</b>",
										"<b>".$langText['NATURE_'.$row['message_nature']]."</b>",
										"<b><a href='communication.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&action=show&message_id=".$row['message_id']."'>".$row['message_subject']."</a></b>",
										"<b>".date(USER_DATE_FORMAT, $row['sent_epoch'])."</b>");
				}
				else
				{
					$content = array(	"&nbsp;",
										format_user_real_name($user_row),
										$langText['NATURE_'.$row['message_nature']],
										"<a href='communication.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&action=show&message_id=".$row['message_id']."'>".$row['message_subject']."</a>",
										date(USER_DATE_FORMAT, $row['sent_epoch']));
				}

				layout_table_row($content);

			}

			layout_table_footer();
		}

		?>

		<br />
		<br />

		</td>
		<td rowspan="2" width="40">&nbsp;</td>
	</tr>
	<tr>
		<td align="middle" valign="top">

        <?php

        if(isset($_REQUEST['action']) && $_REQUEST['action'] == "show" && isset($_REQUEST['message_id']) && is_numeric($_REQUEST['message_id']) && !isset($_REQUEST['send']) && !isset($_REQUEST['delete']))
		{
         	$res = mysql_query(	"SELECT *, UNIX_TIMESTAMP(messages.message_sent) AS sent_epoch
								FROM messages
								WHERE messages.message_id=".$_REQUEST['message_id']."");

			if(mysql_num_rows($res))
			{
				$row = mysql_fetch_array($res);

				if($row['message_from_id'] == 0) {
					$loc = mysql_fetch_array(mysql_query("SELECT location_name FROM locations WHERE location_id=".USER_LOCATION));
					$user_row['user_given_names'] = $loc['location_name'];
					$user_row['user_surname'] = "";
				} else {
					$res_ = mysql_query("SELECT user_given_names, user_surname FROM users WHERE user_id=".$row['message_from_id']);
					if(mysql_num_rows($res_)) {
						$temp_row = mysql_fetch_array($res_);
						$user_row = $temp_row;
					} else {
						$user_row['user_given_names'] = "-";
						$user_row['user_surname'] = "";
					}
				}
				
				$row['message_subject'] = ($row['message_subject'] == "") ? "[".$langText['NO_SUBJECT']."]" : $row['message_subject'];
				
            	list($message, $raw, $hidden) = format_message($row['message_text']);

            	if($row['message_to_id'] == USER_ID)
				{

					$res = mysql_query("UPDATE messages SET message_read=1 WHERE message_id=".$_REQUEST['message_id']);

				?>

				<table border="0" cellspacing="8" cellpadding="0" width="100%">
					<tr>
						<td align="left" valign="top">
							<table cellpadding="6" cellspacing="0" border="1" width="100%">
								<tr>
									<td>
										<b><?php echo $langText['SENT_BY']." ".format_user_real_name($user_row) . " " . $langText['ON'] . " " . date(USER_DATE_FORMAT, $row['sent_epoch'])?></b>
									</td>
								</tr>
								<tr>
									<td>
										<table border="0" cellspacing="0" cellpadding="0">
											<tr>
												<td valign="top" nowrap>
													<b><?php echo $langText['SUBJECT']?> (<?php echo $langText['NATURE_'.$row['message_nature']] ?>):</b>
												</td>
												<td width="2%">&nbsp;</td>
												<td width="97%">
													<?php echo nl2br($row['message_subject'])?>
												</td>
											</tr>
										</table>
									</td>
								</tr>
								<tr>
									<td colspan="2" class="message-content">
										<?php echo $message?>
									</td>
								</tr>
							</table>
						</td>
					</tr>
					<tr>
						<td align="right" valign="top">

							<form name='alter' actio='<?php echo getenv('REQUEST_URI')?>' method='post'>
								<input type='hidden' name='message_id' value='<?php echo $_REQUEST['message_id']?>'>
								<input type='hidden' name='recepient' value='<?php echo $row['user_id']?>'>
								<input type='hidden' name='nature' value='<?php echo $row['message_nature']?>'>
								<input type='hidden' name='subject' value='<?php echo format_reply_subject($row['message_subject'])?>'>
								<input type='hidden' name='message' value='<?php echo format_reply_message($raw, format_user_real_name($row))?>'>
								<input type='hidden' name='hidden' value="<?php echo $hidden?>">
								<input type='submit' class='button' name='reply' value='&lt;&lt;&nbsp;<?php echo $langText['BUTTON_REPLY']?>'>
								&nbsp;
								<input type='submit' class='button' name='delete' value='[&nbsp;<?php echo $langText['BUTTON_DELETE']?>&nbsp;]'>
							</form>

						</td>
					<tr>
				</table>

                <?php

				}
				else
				{
					error("session violation");
				}

			}
			else
				layout_page_info($langText['ERROR_NO_MESSAGE'], 'error');
		}

		?>

		</td>
	</tr>
</table>

<?php

layout_footer();

?>
